<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048		; realtime audio out
-obitreduce.wav	-W		; output to audio file
</CsOptions>
<CsInstruments>

  sr = 48000
  ksmps = 10
  nchnls = 2
  0dbfs = 1

;***************************************************
; bit reduction
;***************************************************
  instr	1

  iamp = ampdbfs(p4)
  icps = p5
  iBits = p6 ; bit depth
  iQuantize = powoftwo(iBits-1) ; find number of discrete steps for this bit depth

; audio generator
  a1 oscili 1, icps ; sine wave
  aQuantize = round(a1*iQuantize)/iQuantize	; quantize audio signal (bit reduce)

; audio out
  outs a1*iamp, aQuantize*iamp ; output smooth sine wave (left), and bit reduced wave (right)

  endin
;***************************************************

</CsInstruments>
<CsScore>

; 	start	dur	amp	cps 	bits
i1	0        1	 -1	440	16
i1	^+2	  .	  .	  .	12
i1	^+2	  .	  .	  .	 8
i1	^+2	  .	  .	  .	 7
i1	^+2	  .	  .	  .	 6
i1	^+2	  .	  .	  .	 5
i1	^+2	  .	  .	  .	 4
i1	^+2	  .	  .	  .	 3
i1	^+2	  .	  .	  .	 2
i1	^+2	  .	  .	  .	 1

e

</CsScore>
</CsoundSynthesizer>
