<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048    ; realtime audio out
-obitreduce_dynamic.wav  -W  ; output to audio file
</CsOptions>
<CsInstruments>

  sr = 48000
  ksmps = 10
  nchnls = 2
  0dbfs = 1

;***************************************************
; bit reduction
;***************************************************
  instr  1

  iamp = ampdbfs(p4)
  icps = p5
  kBits line 8, p3, 1 ; bit depth
  kQuantize = round(powoftwo(kBits-1)) ; find number of discrete steps for this bit depth
  ; as we allow fractional bit depth we need to round this value too

; audio generator
  a1 oscili 1, icps ; sine wave
  aQuantize = round(a1 * kQuantize)/kQuantize ; quantize audio signal (bit reduce)

; audio out
  outs a1*iamp, aQuantize*iamp ; output smooth sine wave (left), and bit reduced wave (right)

  endin
;***************************************************

</CsInstruments>
<CsScore>

;   start  dur  amp  cps
i1  0      16  -3  440

e

</CsScore>
</CsoundSynthesizer>
