<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048		; realtime audio out
-oclassicWaveforms.wav			; output to audio file 
</CsOptions>
<CsInstruments>

	sr = 44100  
	ksmps = 10
	nchnls = 2	
	0dbfs = 1

;***************************************************
;ftables
;***************************************************

	giSine		ftgen	0, 0, 65536, 10, 1					; sine
	giSaw		ftgen	0, 0, 65536, 7, 1, 65536, -1				; saw
	giSquare	ftgen	0, 0, 1024,  7, -1, 512, -1, 0, 1, 512, 1		; square
	giTriangle	ftgen	0, 0, 65536, 7, 0, 16384, 1, 32768, -1, 16384, 0	; triangle 
	giPulse		ftgen	0, 0, 4096, 2, 1, 0					; 1 at first index, the rest is zeroes

	giSaw_A		ftgen	0, 0, 65536, 10, 1, 1/2, 1/3, 1/4, 1/5, 1/6, 1/7, 1/8,\	; (additive) saw wave
						1/9, 1/10, 1/11, 1/12, 1/13, 1/14,\	
						1/15, 1/16, 1/17, 1/18, 1/19, 1/20	

	giSquare_A	ftgen	0, 0, 65536, 10, 1, 0, 1/3, 0, 1/5, 0, 1/7, 0, 1/9, \	; (additive) square wave
						0, 1/11, 0, 1/13, 0, 1/15, 0, \
						1/17, 0, 1/19

	giTriangle_A	ftgen	0, 0, 65536, 9, 1, 1, 0, \				; (additive)triangle wave
						3, 1/(3*3), 180, \			
						5, 1/(5*5), 0, \			
						7, 1/(7*7), 180, \		
						9, 1/(9*9), 0, \		
						11, 1/(11*11), 180, \
						13, 1/(13*13), 0, \
						15, 1/(15*15), 180, \
						17, 1/(17*17), 0, \
						19, 1/(19*19), 180

	giPulse_A	ftgen	0, 0, 65536, 30, giPulse, 1, 20, 44100 		; resynthesize the pulse wave with N harmonics

;***************************************************
; simple oscillator instrument
;***************************************************
	instr	1

	icps		= p4
	iwaveSelect	= p5
	
; select waveform
	iwave		= giSine
	iwave		= (iwaveSelect == 2 ? giTriangle_A : iwave)
	iwave		= (iwaveSelect == 3 ? giSquare_A : iwave)
	iwave		= (iwaveSelect == 4 ? giSaw_A : iwave)
	iwave		= (iwaveSelect == 5 ? giPulse_A : iwave)
	iwave		= (iwaveSelect == 6 ? giTriangle : iwave)
	iwave		= (iwaveSelect == 7 ? giSquare : iwave)
	iwave		= (iwaveSelect == 8 ? giSaw : iwave)
	iwave		= (iwaveSelect == 9 ? giPulse : iwave)

; audio generator
	if iwave == giPulse goto pulse
	a1		oscili	0.8, icps, iwave
	goto nopulse
pulse:
	a1		mpulse 0.8, 1/icps
nopulse:

; audio out
	outs		a1, a1
	endin
;***************************************************

;***************************************************
; additive triangle wave, two different phase combinations
;***************************************************
	instr	2

	icps		= p4
	iamp		= 0.7

	a_1		oscili	iamp*1, 	icps*1, giSine, 0
	a_2		oscili	iamp*1/(3*3), 	icps*3, giSine, 0.5
	a_3		oscili	iamp*1/(5*5), 	icps*5, giSine, 0
	a_4		oscili	iamp*1/(7*7), 	icps*7, giSine, 0.5
	a_5		oscili	iamp*1/(9*9), 	icps*9, giSine, 0
	a_6		oscili	iamp*1/(11*11),	icps*11, giSine, 0.5
	a_7		oscili	iamp*1/(13*13),	icps*13, giSine, 0
	a_8		oscili	iamp*1/(15*15),	icps*15, giSine, 0.5
	a1		sum a_1, a_2, a_3, a_4, a_4, a_5, a_6, a_7, a_8

	a2_1		oscili	iamp*1, 	icps*1, giSine, 0
	a2_2		oscili	iamp*1/(3*3), 	icps*3, giSine, 0
	a2_3		oscili	iamp*1/(5*5), 	icps*5, giSine, 0
	a2_4		oscili	iamp*1/(7*7), 	icps*7, giSine, 0
	a2_5		oscili	iamp*1/(9*9), 	icps*9, giSine, 0
	a2_6		oscili	iamp*1/(11*11),	icps*11, giSine, 0
	a2_7		oscili	iamp*1/(13*13),	icps*13, giSine, 0
	a2_8		oscili	iamp*1/(15*15),	icps*15, giSine, 0
	a2		sum a2_1, a2_2, a2_3, a2_4, a2_4, a2_5, a2_6, a2_7, a2_8

; audio out
	outs		a1, a2
	endin
;***************************************************

</CsInstruments>
<CsScore>

; 	start	dur	cps	wave
i1	0	1	220	1
i1	^+2	.	.	2
i1	^+2	.	.	3
i1	^+2	.	.	4
i1	^+2	.	.	5
i1	^+2	.	.	9
i1	^+2	.	.	8
i1	^+2	.	.	7
i1	^+2	.	.	6

; 	start	dur	cps	
i2	19	1	220	


</CsScore>
</CsoundSynthesizer>
