<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048		; realtime audio out
-odownsample.wav		; output to audio file
</CsOptions>
<CsInstruments>

	sr = 48000
	ksmps = 100
	nchnls = 2
	0dbfs = 1

;***************************************************
; downsampling
;***************************************************
instr	1

 iamp = ampdbfs(p4)
 icps = p5
 iSampleRate = p6 ; downsample to this sample rate

; audio generator
 a1 oscili 1, icps ; sine wave

; downsample
 aSampleClock mpulse 1, 1/iSampleRate ; new sample clock
 aDownsamp samphold a1, aSampleClock ; sample and hold (downsample)

; audio out
 outs a1*iamp, aDownsamp*iamp ; output clean signal (left), and downsampled wave (right)

endin
;***************************************************

</CsInstruments>
<CsScore>

; 	start	dur	amp	cps 	samplerate
i1	0	1	-0	480	48000
i1	^+2	.	.	.	24000
i1	^+2	.	.	.	12000
i1	^+2	.	.	.	9600
i1	^+2	.	.	.	6857
i1	^+2	.	.	.	5333
i1	^+2	.	.	.	4800

i1	^+3	.	.	.	2400
i1	^+2	.	.	.	1600
i1	^+2	.	.	.	1200
i1	^+2	.	.	.	1066.6

i1	^+3	.	.	.	979		; nyquist +
i1	^+2	.	.	.	960		; nyquist
i1	^+2	.	.	.	941		; nyquist -

i1	^+3	.	.	.	500
i1	^+2	.	.	.	400
i1	^+2	.	.	.	250
i1	^+2	.	.	.	200
i1	^+2	.	.	.	150
i1	^+2	.	.	.	100

e

</CsScore>
</CsoundSynthesizer>
