<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048		; realtime audio out
-odownsample_linear.wav		; output to audio file
</CsOptions>
<CsInstruments>

	sr = 48000
	ksmps = 1
	nchnls = 2
	0dbfs = 1

;***************************************************
;ftables
;***************************************************

	giSine		ftgen	0, 0, 65536, 10, 1	; sine

;***************************************************
; downsampling
;***************************************************
	instr	1

	iamp		= ampdbfs(p4)
	icps		= p5
	iSampleRate	= p6				; downsample to this sample rate
	iRatio		= int(sr/iSampleRate)		; ratio of the input to output sample rate

; audio generator
	kVib = 0 ;oscil	icps*0.1, 1, giSine	; optional vibrato to demonstrate sideband movement
	a1 oscili	1, icps+kVib, giSine	; sine wave

; downsample
	a1 butterlp a1, iSampleRate/2	; pre filter (really not the best filter for this purpose, but providing a simple example)
												; should use a brickwall filter with linear phase response
	kSampleClock metro iSampleRate		; new sample clock
	k1		downsamp a1			; convert to k-rate (no other change to the signal, as kr=sr)
	iOld		init 0				; starting point for the linear interpolation
linear:
	iNew		= i(k1)				; ending point for the linear interpolation
	kLine		line iOld, (1/kr)*iRatio, iNew	; linear interpolation
	iOld		= iNew				; update starting point for linear interpolation
	rireturn							; reinitialize only the line segment generator
if kSampleClock == 0 goto done
reinit linear
done:

	aDown		upsamp kLine 			; convert to a-rate
	aDown		butterlp aDown, iSampleRate/2	; post filter (really not the best filter for this purpose, but providing a simple example)
												; should use a brickwall filter with linear phase response

; audio out
	outs		a1*iamp, aDown*iamp		; output clean signal (left), and downsampled wave (right)

	endin
;***************************************************

</CsInstruments>
<CsScore>

; 	start	dur	amp	cps 	samplerate
i1	0	1	-0	480	48000
i1	^+2	.	.	.	24000
i1	^+2	.	.	.	12000
i1	^+2	.	.	.	9600
i1	^+2	.	.	.	6857
i1	^+2	.	.	.	5333
i1	^+2	.	.	.	4800

i1	^+3	.	.	.	2400
i1	^+2	.	.	.	1600
i1	^+2	.	.	.	1200
i1	^+2	.	.	.	1066.6

i1	^+3	.	.	.	979		; nyquist +
i1	^+2	.	.	.	960		; nyquist
i1	^+2	.	.	.	942		; nyquist -

i1	^+3	.	.	.	480
i1	^+2	.	.	.	400
i1	^+2	.	.	.	250
i1	^+2	.	.	.	200
i1	^+2	.	.	.	150
i1	^+2	.	.	.	100

e

</CsScore>
</CsoundSynthesizer>
