<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048		; realtime audio out
-oPanDelay.wav			; output to audio file
</CsOptions>
<CsInstruments>

	sr = 48000
	ksmps = 10
	nchnls = 2
	0dbfs = 1

;***************************************************
;ftables
;***************************************************

	giSine		ftgen	0, 0, 65536, 10, 1	; sine
	giSample	ftgen	0, 0, 0, 1, "Askil2_4_mono.wav", 0, 0, 0
	giSample	ftgen	0, 0, 0, 1, "MoodySlide2_110.wav", 0, 0, 0

;***************************************************
; Interaural time delay panning
;***************************************************
instr	1

 iamp = ampdbfs(p4)
 icps = p5
 isource = p6

; audio generator
if isource == 1 then
 a1 loscil iamp, 1, giSample, 1
else
 a1 oscil iamp, icps, giSine
 ;a1 rnd31 iamp,1
 ;a1 mpulse iamp, 1/icps
endif

; pan

 iMaxIDT = 0.6 ; max interaural time delay (approx 20cm distance, 340m per sec)
 kPan line 0, p3, 1
 aDelTimeL interp kPan*iMaxIDT
 aDelTimeR interp (1-kPan)*iMaxIDT

 aLeft vdelay a1, aDelTimeL, iMaxIDT+0.1
 aRight vdelay a1, aDelTimeR, iMaxIDT+0.1

; audio out
 outs aLeft, aRight

endin

</CsInstruments>
<CsScore>

; 	start	dur	amp	cps     source
i1	1	4	-3	110     0
i1	^+5	.	.	220     .
i1	^+5	.	.	440     .
i1	^+5	.	.	660     .
i1	^+5	.	.	880     .
i1	^+5	.	.	1320    .
i1	^+5	.	.	1760    .
i1	^+5	8	.	.       1

e

</CsScore>
</CsoundSynthesizer>
