<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048 ; realtime audio out
-ohardclip.wav ; output to audio file
</CsOptions>
<CsInstruments>

  sr = 48000
  ksmps = 100
  nchnls = 2
  0dbfs = 1

;***************************************************
;ftables
;***************************************************

 giSine ftgen 0, 0, 65536, 10, 1 ; sine
 ;giSample ftgen 0, 0, 0, 1, "StruglKor2mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "Askil2_4_mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "ce01_mono.wav", 0, 0, 0
 giSample ftgen 0, 0, 0, 1, "MoodySlide2_110.wav", 0, 0, 0

;***************************************************
; Hard clip
;***************************************************
instr 2

 iamp = ampdbfs(p4) ; Amp in -dB
 icps = p5 ; Frequency for the tone generator
 iClip = p6 ; Clip level (in fraction of full level, e.g. 0.5 clips at 50%)
 iMakeupGain = 1/iClip ; Make up for gain loss in clipping stage

; amp envelope, so we can see some dynamic spectral changes related to the distortion effect
 iAttack = 0.01
 iDecay = 1
 iSustainLev = 0.5
 iRelease = 0.7
 aEnv adsr iAttack, iDecay, iSustainLev, iRelease

; audio generator
 a1 oscili aEnv, icps, giSine ; sine tone, with envelope
 a1 loscil 1, 1, giSample, 1 ; test sample

; hard clip
 a1 limit a1, -iClip, iClip ; hard clipping

; output gain
 a1 = a1*iamp*iMakeupGain

; audio out
 outs a1, a1
endin
;***************************************************

</CsInstruments>
<CsScore>

;hard clip
;   start  dur  amp  cps   clip
i2  0      2    -5   440   1.0
i.  ^+3    2    -5   440   0.8
i.  ^+3    2    -5   440   0.6
i.  ^+3    2    -5   440   0.5
i.  ^+3    2    -5   440   0.4
i.  ^+3    2    -5   440   0.3
i.  ^+3    2    -5   440   0.2
i.  ^+3    2    -5   440   0.1
</CsScore>
</CsoundSynthesizer>
