<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048    ; realtime audio out
-ointermodulation_tanh_dist.wav      ; output to audio file
</CsOptions>
<CsInstruments>

  sr = 48000
  ksmps = 100
  nchnls = 2
  0dbfs = 1

;***************************************************
;ftables
;***************************************************

 giSine ftgen 0, 0, 65536, 10, 1 ; sine
 ;giSample ftgen 0, 0, 0, 1, "StruglKor2mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "Askil2_4_mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "ce01_mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "LAep3_mono.wav", 0, 0, 0
 giSample ftgen 0, 0, 0, 1, "MoodySlide2_110.wav", 0, 0, 0

;***************************************************
; tanh distortion
;***************************************************
 instr 6

 iamp = ampdbfs(p4) ; Amp in -dB
 icps = p5 ; Frequency for the tone generator
 kDrive = p6

; amp envelope, so we can see some dynamic spectral changes related to the distortion effect
 iAttack = 0.01
 iDecay = 1
 iSustainLev = 0.5
 iRelease = 0.7
 aEnv adsr iAttack, iDecay, iSustainLev, iRelease

; audio generator
  a1_1 oscil aEnv, icps, giSine			; fundamental
  a1_2 oscil aEnv, icps*semitone(4), giSine	; + major third up
  a1 = (a1_1 + a1_2) * 0.5

; distortion
 a2 = tanh(a1*kDrive) 
 a2_1 = tanh(a1_1*kDrive)
 a2_2 = tanh(a1_2*kDrive)

; audio out
 outs a2_1*iamp, a2_2*iamp
; outs a2*iamp, a2*iamp
endin
;***************************************************

</CsInstruments>
<CsScore>

; tanh dist
;      amp  cps  drive
i6  0  2  -5  440  1
i6  ^+3  .  .  .  2
i6  ^+3  .  .  .  4
i6  ^+3  .  .  .  7
i6  ^+3  .  .  .  14
</CsScore>
</CsoundSynthesizer>
