<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048    ; realtime audio out
-olpf18.wav      ; output to audio file
</CsOptions>
<CsInstruments>

  sr = 48000
  ksmps = 100
  nchnls = 2
  0dbfs = 1

;***************************************************
;ftables
;***************************************************

 giSine ftgen 0, 0, 65536, 10, 1 ; sine
 ;giSample ftgen 0, 0, 0, 1, "StruglKor2mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "Askil2_4_mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "ce01_mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "LAep3_mono.wav", 0, 0, 0
 giSample ftgen 0, 0, 0, 1, "MoodySlide2_110.wav", 0, 0, 0

;***************************************************
; lpf18 filter
;***************************************************
 instr 6

 iamp = ampdbfs(p4) ; Amp in -dB
 kcutoff = p5
 kresonance = p6
 kdistortion = p7

; amp envelope, so we can see some dynamic spectral changes related to the distortion effect
 iAttack = 0.01
 iDecay = 1
 iSustainLev = 0.5
 iRelease = 0.7
 aEnv adsr iAttack, iDecay, iSustainLev, iRelease

; audio generator
 a1 loscil 1, 1, giSample, 1 ; test sample

; filter
 a2 lpf18 a1, kcutoff, kresonance, kdistortion

; audio out
 outs a2*iamp, a2*iamp
endin
;***************************************************

</CsInstruments>
<CsScore>

; tanh dist
;      amp  cutoff  reso  drive
i6  0   2  -5  3000  0.3  0.3
i6  ^+3  .  .  1000  0.7  0.3
i6  ^+3  .  .  1000  0.5  3
</CsScore>
</CsoundSynthesizer>
