<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048 ; realtime audio out
-osin_x.wav ; output to audio file
</CsOptions>
<CsInstruments>

  sr = 48000
  ksmps = 100
  nchnls = 2
  0dbfs = 1

;***************************************************
;ftables
;***************************************************

 giSine ftgen 0, 0, 65536, 10, 1 ; sine
 ;giSample ftgen 0, 0, 0, 1, "StruglKor2mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "Askil2_4_mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "ce01_mono.wav", 0, 0, 0
 giSample ftgen 0, 0, 0, 1, "MoodySlide2_110.wav", 0, 0, 0

;***************************************************
; Hard clip
;***************************************************
instr 2

 iamp = ampdbfs(p4) ; Amp in -dB
 icps = p5 ; Frequency for the tone generator
 iWrap_pregain = p6 ; Pregain before sin(x)
 
; amp envelope, so we can see some dynamic spectral changes related to the distortion effect
 iAttack = 0.01
 iDecay = 1
 iSustainLev = 0.5
 iRelease = 0.7
 aEnv adsr iAttack, iDecay, iSustainLev, iRelease

; audio generator
 a1 oscili aEnv, icps, giSine ; sine tone, with envelope
 a1 loscil 1, 1, giSample, 1 ; test sample
 aclean = a1

; sin(x)
 a1 = sin(a1*iWrap_pregain)
 
; output gain
 a1 = a1*iamp
 aclean *= iamp

; audio out
 outs a1, aclean
endin
;***************************************************

</CsInstruments>
<CsScore>

;sin(x) wave wrap
;   start  dur  amp  cps   pregain
i2  0      2    -1   440   1.0
i.  ^+3    2    -1   440   1.5
i.  ^+3    2    -1   440   2.0
i.  ^+3    2    -1   440   3.0
i.  ^+3    2    -1   440   5.0
i.  ^+3    2    -1   440   10.0
</CsScore>
</CsoundSynthesizer>
