
<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048		; realtime audio out
-oslopedelay_distfilt.wav		; output to audio file 
</CsOptions>
<CsInstruments>

	sr = 48000
	ksmps = 100
	nchnls = 2	
	0dbfs = 1

;***************************************************
;ftables
;***************************************************

	giSine		ftgen	0, 0, 65536, 10, 1				; sine
	giSample1	ftgen	0, 0, 0, 1, "StruglKor2mono.wav", 0, 0, 0
	;giSample	ftgen	0, 0, 0, 1, "Askil2_4_mono.wav", 0, 0, 0
	;giSample	ftgen	0, 0, 0, 1, "ce01_mono.wav", 0, 0, 0
	giSample2	ftgen	0, 0, 0, 1, "LAep3_mono.wav", 0, 0, 0
	giSample3	ftgen	0, 0, 0, 1, "MoodySlide2_110.wav", 0, 0, 0

	giSine		ftgen	0, 0, 65536, 10, 1				; sine
;***************************************************
; slope based delay distortion
;***************************************************
	instr	8

	iamp		= ampdbfs(p4)		; Amp in -dB
	icps		= p5			; Frequency for the tone generator
	kDrive		= p6			; distortion drive
	iSlope		= p7			; amount of slope influence on delay time
	iDuty		= p8			; amount of duty influence on delay time

; amp envelope, so we can see some dynamic spectral changes related to the distortion effect
	iAttack		= 0.01
	iDecay		= 1
	iSustainLev	= 0.5
	iRelease	= 0.7
	aEnv		adsr	iAttack, iDecay, iSustainLev, iRelease

; audio generator
	a1		oscili	aEnv, 440, giSine
        adeclick        linen 1, 0.001, p3, 0.1
	a1		loscil	adeclick, 1, giSample3, 1			; test sample

; distortion

	ain		= a1 * kDrive
	kPostGain	= 1/kDrive

	an1		delay1	ain		; delay audio by 1 sample
	aslope		= ain - an1		; find difference between samples (= slope of the waveform)

	kslope		= iSlope * kDrive
	kduty		= iDuty * kDrive

	atemp    	delayr  0.1                          
	a2     		deltapi butterlp(((2-a1)*kduty) + (aslope * kslope) + 0.004, 400)	; Slope&Duty controlled delay time
			delayw  	ain

;	a2		butterlp a2, 5000


; audio out
	outs		a2*iamp*kPostGain, a2*iamp*kPostGain
	endin
;***************************************************

</CsInstruments>
<CsScore>

; slope based delay dist
;			amp	cps	drive	slope	duty	

; test amount of slope mod
i8	0	2	-5	440	0.09	0.05	0.0	
i8	^+3	.	.	.	.	0.3	0.0	
i8	^+3	.	.	.	.	1.5	0.0	
i8	^+3	.	.	.	.	4	0.0	
i8	^+3	.	.	.	.	8	0.0	
; test amount of duty cycle mod
i8	^+4	.	.	.	.	0.0	0.001	
i8	^+3	.	.	.	.	0.0	0.005	
i8	^+3	.	.	.	.	0.0	0.025	
i8	^+3	.	.	.	.	0.0	0.042	
; test combinations of slope and duty cycle
i8	^+4	.	.	.	.	1.65	0.014	
i8	^+3	.	.	.	.	4.2	0.011	
i8	^+3	.	.	.	.	6.0	0.007	
i8	^+3	.	.	.	.	6.0	0.020	

; suitable single voice dist (too much intermodulation)
i8	^+4	.	.	.	0.04	1.4	0.009	
i8	^+4	.	.	.	0.07	.	.	

; suitable settings for polyphonic dist, play chords
i8	^+4	.	.	.	0.07	0.1	0.003	
i8	^+4	.	.	. 	0.07	0.001	0.005	
e


</CsScore>
</CsoundSynthesizer>
