<Cabbage>
form size(680, 400), caption("Superformula waveshaper"), pluginId("suwa"), colour(5,25,45)
rslider channel("inlevel"), bounds(10, 15, 80, 80), text("input"), range(0, 20, 1, 0.35)
rslider channel("offset"), bounds(100, 15, 80, 80), text("offset"), range(-1, 1, 0, 1)
combobox channel("formula"), bounds(190, 15, 90, 20), items("super", "ginger", "poly", "cheb", "ikeda", "ikeda2", "folium", "scarabeus", "talbot", "hypocycloid" ), value(1)
button channel("polar"), text("pol"), bounds(425, 20, 43, 14), colour:0("darkgreen"), colour:1("red"), value(0)
button channel("norm"), text("norm"), bounds(485, 20, 43, 14), colour:0("darkgreen"), colour:1("red"), value(0)
button channel("norm2"), text("n^2"), bounds(485, 35, 43, 14), colour:0("darkgreen"), colour:1("red"), value(0)
button channel("peak"), text("peak"), bounds(485, 50, 43, 14), colour:0("darkgreen"), colour:1("red"), value(0)
button channel("lim"), text("lim"), bounds(535, 20, 43, 14), colour:0("darkgreen"), colour:1("red"), value(0)
button channel("ref_lim"), text("ref_lim"), bounds(535, 35, 43, 14), colour:0("darkgreen"), colour:1("red"), value(0)
rslider channel("outlevel"), bounds(580, 15, 80, 80), text("output"), range(0, 2, 1, 0.35)

rslider channel("a"), bounds(10, 95, 80, 80), text("a"), range(0.5, 5, 2, 0.35), visible(1), identChannel("id_a")
rslider channel("b"), bounds(90, 95, 80, 80), text("b"), range(0.5, 5, 2, 0.35), visible(1), identChannel("id_b")
button channel("mlink"), text("link"), bounds(170, 105, 43, 14), colour:0("green"), colour:1("red"), value(0)
button channel("mint"), text("int"), bounds(170, 125, 43, 14), colour:0("green"), colour:1("red"), value(0)
rslider channel("m1"), bounds(210, 95, 80, 80), text("m1"), range(1, 20, 2, 0.35), visible(1), identChannel("id_m1")
rslider channel("m2"), bounds(290, 95, 80, 80), text("m2"), range(1, 20, 2, 0.35), visible(1), identChannel("id_m2")
button channel("nlink"), text("link"), bounds(370, 105, 43, 14), colour:0("green"), colour:1("red"), value(0)
rslider channel("n1"), bounds(410, 95, 80, 80), text("n1"), range(1, 20, 2, 0.35), visible(1), identChannel("id_n1")
rslider channel("n2"), bounds(490, 95, 80, 80), text("n2"), range(1, 20, 2, 0.35), visible(1), identChannel("id_n2")
rslider channel("n3"), bounds(580, 95, 80, 80), text("n3"), range(1, 20, 2, 0.35), visible(1), identChannel("id_n3")

gentable bounds(260, 175, 400, 100), identChannel("scopetable"), tableNumbers(1), tableColours("lightblue"), ampRange(-1,1,1), zoom(-1)
signaldisplay bounds(4, 175, 250, 220), colour("lime"), backgroundColour("black"), displayType("lissajous"), signalVariable("aplotx","aploty")

csoundoutput bounds(260, 280, 400, 110)
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n --displays
</CsOptions>
<CsInstruments>
ksmps = 64
nchnls = 2
0dbfs=1

giview	ftgen	1,0,256,10,0

instr 1
a1 inch 1
a2 inch 2
kinlevel chnget "inlevel"
koffset chnget "offset"
a1 = (a1 * kinlevel)+koffset
a2 = (a2 * kinlevel)+koffset
ka chnget "a"
kb chnget "b"
km1 chnget "m1"
km2 chnget "m2"
kmlink chnget "mlink"
if kmlink > 0 then
  chnset km1, "m1"
  chnset km1, "m2"
endif
kmint chnget "mint"
if kmint > 0 then
  km1 = round(km1)
  km2 = round(km2)
  chnset km1, "m1"
  chnset km2, "m2"
endif
kn1 chnget "n1"
kn2 chnget "n2"
kn3 chnget "n3"
knlink chnget "nlink"
if knlink > 0 then
  chnset kn1, "n2"
  chnset kn1, "n3"
endif

; control smoothing
ifiltfq = 20
ka tonek ka, ifiltfq
kb tonek kb, ifiltfq
km1 tonek km1, ifiltfq
km2 tonek km2, ifiltfq
kn1 tonek kn1, ifiltfq
kn2 tonek kn2, ifiltfq
kn3 tonek kn3, ifiltfq
ka tonek ka, ifiltfq/2
kb tonek kb, ifiltfq/2
km1 tonek km1, ifiltfq/2
km2 tonek km2, ifiltfq/2
kn1 tonek kn1, ifiltfq/2
kn2 tonek kn2, ifiltfq/2
kn3 tonek kn3, ifiltfq/2
ka tonek ka, ifiltfq/3
kb tonek kb, ifiltfq/3
km1 tonek km1, ifiltfq/3
km2 tonek km2, ifiltfq/3
kn1 tonek kn1, ifiltfq/3
kn2 tonek kn2, ifiltfq/3
kn3 tonek kn3, ifiltfq/3
ka tonek ka, ifiltfq/4
kb tonek kb, ifiltfq/4
km1 tonek km1, ifiltfq/4
km2 tonek km2, ifiltfq/4
kn1 tonek kn1, ifiltfq/4
kn2 tonek kn2, ifiltfq/4
kn3 tonek kn3, ifiltfq/4


; for normalization and wave display:
; make a parallel signal process, running a sine wave through the shaper
; measure the output amp if this, and use that to recalculate a normalization factor for the audio process
; the sine wave can also be used as a waveshaper shape plot
irefcps = 50
aref oscil kinlevel*0.63, irefcps
aref phasor irefcps
aref = (aref-0.5)*2
aref *= kinlevel*0.63
aref += koffset

Show = "visible(1)"
Shide = "visible(0)"

kformula chnget "formula"
kformulaupdate changed kformula
if kformula == 1 then
  ; superformula
  if kformulaupdate > 0 then
    ; gui updates
    chnset Show, "id_a"
    chnset Show, "id_b"
    chnset Show, "id_m1"
    chnset Show, "id_m2"
    chnset Show, "id_n1"
    chnset Show, "id_n2"
    chnset Show, "id_n3"
  endif

  ay1 = (((abs(cos((a1*$M_PI*2*km1)/4)/ka)^kn2)+
            abs(sin((a1*$M_PI*2*km2)/4)/kb)^kn3)^(-1/kn1))/($M_PI*2)
  ay2 = (((abs(cos((a2*$M_PI*2*km1)/4)/ka)^kn2)+
            abs(sin((a2*$M_PI*2*km2)/4)/kb)^kn3)^(-1/kn1))/($M_PI*2)
  ay_ref = (((abs(cos((aref*$M_PI*2*km1)/4)/ka)^kn2)+
            abs(sin((aref*$M_PI*2*km2)/4)/kb)^kn3)^(-1/kn1))/($M_PI*2)

elseif kformula == 2 then
  ; gingerbreadman map hack
  ; adapted by Oeyvind from the map at https://demonstrations.wolfram.com/VariationsOfTheGingerbreadmanMap/
  ; sin(x) in the formula is replaced with sin(a1*$M_PI*2), adding the phase scaling parameter am1
  ; sin(y) in the formula is replaced with cos(a1*$M_PI*2), adding the phase scaling parameter am2
  ; the (1+lambda/1000) in the formula is replaced with (an1*5), by emprirical experimentation
  if kformulaupdate > 0 then
    ; gui updates
    chnset Shide, "id_a"
    chnset Shide, "id_b"
    chnset Show, "id_m1"
    chnset Show, "id_m2"
    chnset Show, "id_n1"
    chnset Shide, "id_n2"
    chnset Shide, "id_n3"
  endif

  an1 interp tonek(kn1,1)
  am1 interp tonek(km1,1)
  am2 interp tonek(km2,1)
  ay1 = sin(a1*$M_PI*2*am1)+(an1*5)*cos(a1*$M_PI*2*am2)
  ay2 = sin(a2*$M_PI*2*am1)+(an1*5)*cos(a2*$M_PI*2*am2)
  ay_ref = sin(aref*$M_PI*2*am1)+(an1*5)*cos(aref*$M_PI*2*am2)
  ay1 = ay1*ampdbfs(-((am2)+(an1*am2*0.05)))
  ay2 = ay2*ampdbfs(-((am2)+(an1*am2*0.05)))
  ay_ref = ay_ref*ampdbfs(-((am2)+(an1*am2*0.05)))
endif

if kformula == 3 then
  ; polynomial Csound opcode
  if kformulaupdate > 0 then
    ; gui updates
    chnset Show, "id_a"
    chnset Show, "id_b"
    chnset Show, "id_m1"
    chnset Show, "id_m2"
    chnset Show, "id_n1"
    chnset Show, "id_n2"
    chnset Show, "id_n3"
  endif

  ay1 polynomial a1, 0, ka, kb, km1, km2, kn1, kn2, kn3
  ay2 polynomial a2, 0, ka, kb, km1, km2, kn1, kn2, kn3
  ay_ref polynomial aref, ka, kb, km1, km2, kn1, kn2, kn3
endif

if kformula == 4 then
  ; chebyshevpoly Csound opcode
  if kformulaupdate > 0 then
    ; gui updates
    chnset Show, "id_a"
    chnset Show, "id_b"
    chnset Show, "id_m1"
    chnset Show, "id_m2"
    chnset Show, "id_n1"
    chnset Show, "id_n2"
    chnset Show, "id_n3"
  endif

  ay1 chebyshevpoly a1, 0, ka, kb, km1, km2, kn1, kn2, kn3
  ay2 chebyshevpoly a2, 0, ka, kb, km1, km2, kn1, kn2, kn3
  ay_ref chebyshevpoly aref, ka, kb, km1, km2, kn1, kn2, kn3
endif

if kformula == 5 then
  ; Ikeda map: https://en.wikipedia.org/wiki/Ikeda_map
  ; original: A, B, C are parameters,
  ; zn is the electrical field and we replace that with our phase value (audio in)
  ; zn = a + b*zn*e^i(abs(zn^2)+c)
  ; since A is just an offset and C is just an inconvenient amp scaling they are omitted
  if kformulaupdate > 0 then
    ; gui updates
    chnset Shide, "id_a"
    chnset Show, "id_b"
    chnset Show, "id_m1"
    chnset Show, "id_m2"
    chnset Shide, "id_n1"
    chnset Shide, "id_n2"
    chnset Shide, "id_n3"
  endif

  am1 interp tonek(km1,1)
  am2 interp tonek(km2,1)
  ay1 = kb*sin(a1*$M_PI*2*am1)*exp(cos(a1*$M_PI*2*am2)^2)
  ay2 = kb*sin(a2*$M_PI*2*am1)*exp(cos(a2*$M_PI*2*am2)^2)
  ay_ref = kb*sin(aref*$M_PI*2*am1)*exp(cos(aref*$M_PI*2*am2)^2)
endif

if kformula == 6 then
  ; Ikeda map: https://en.wikipedia.org/wiki/Ikeda_map
  ; 2d version of the above
  ; U is the only parameter,
  ; u(xn*cos(tn)-yn*sin(tn)
  ; u = ka, t = 0.4-(6/1+xn^2+yn^2)
  ; xn in the formula is replaced with sin(a1*$M_PI*2), adding the phase scaling parameter am1
  ; yn in the formula is replaced with cos(a1*$M_PI*2), adding the phase scaling parameter am2
  ;
  if kformulaupdate > 0 then
    ; gui updates
    chnset Shide, "id_a"
    chnset Show, "id_b"
    chnset Show, "id_m1"
    chnset Show, "id_m2"
    chnset Show, "id_n1"
    chnset Show, "id_n2"
    chnset Shide, "id_n3"
  endif

  am1 interp tonek(km1,1)
  am2 interp tonek(km2,1)
  an1 interp tonek(kn1,1)
  an2 interp tonek(kn2,1)
  at1 = 0.4-(6/(1+sin(a1*$M_PI*2*an1)^2+cos(a1*$M_PI*2*an2)^2))
  ay1 = kb*(sin(a1*$M_PI*2*am1)*cos(at1)-cos(a1*$M_PI*2*am2)*sin(at1))
  at2 = 0.4-(6/(1+sin(a2*$M_PI*2*an1)^2+cos(a2*$M_PI*2*an2)^2))
  ay2 = kb*(sin(a2*$M_PI*2*am1)*cos(at2)-cos(a2*$M_PI*2*am2)*sin(at2))
  atref = 0.4-(6/(1+sin(aref*$M_PI*2*an1)^2+cos(aref*$M_PI*2*an2)^2))
  ay_ref = kb*(sin(aref*$M_PI*2*am1)*cos(atref)-cos(aref*$M_PI*2*am2)*sin(atref))

endif

if kformula == 7 then
  ; from Christian on Csound list:
  ;aT  = ain*$M_PI*2
  ; folium: a1 = cos(aT) * (sin(aT)*sin(aT) - ka)
  if kformulaupdate > 0 then
    ; gui updates
    chnset Show, "id_a"
    chnset Shide, "id_b"
    chnset Show, "id_m1"
    chnset Show, "id_m2"
    chnset Shide, "id_n1"
    chnset Shide, "id_n2"
    chnset Shide, "id_n3"
  endif

  ay1 = cos(a1*$M_PI*2*km1)* (sin(a1*$M_PI*2*km2)^2-ka)
  ay2 = cos(a2*$M_PI*2*km1)* (sin(a2*$M_PI*2*km2)^2-ka)
  ay_ref = cos(aref*$M_PI*2*km1)* (sin(aref*$M_PI*2*km2)^2-ka)

endif

if kformula == 8 then
  ; from Christian on Csound list:
  ;aT  = ain*$M_PI*2
  ; talbot:
  ;  ax = krx * cos(aT) * (1 + ka * sin(aT)*sin(aT))
  ;  ay = kry * sin(aT) * (1 - ka - ka*cos(aT)*cos(aT))
  if kformulaupdate > 0 then
    ; gui updates
    chnset Show, "id_a"
    chnset Show, "id_b"
    chnset Show, "id_m1"
    chnset Show, "id_m2"
    chnset Shide, "id_n1"
    chnset Shide, "id_n2"
    chnset Shide, "id_n3"
  endif

  ay1 = ka*cos(a1*$M_PI*2*km1)*(1+kb*(sin(a1*$M_PI*2*km2)^2))
  ay2 = ka*cos(a2*$M_PI*2*km1)*(1+kb*(sin(a2*$M_PI*2*km2)^2))
  ay_ref = ka*cos(aref*$M_PI*2*km1)*(1+kb*(sin(aref*$M_PI*2*km2)^2))

endif

if kformula == 9 then
  ; from Christian on Csound list:
  ;aT  = ain*$M_PI*2
  ; scarabeus: a1 = ka*cos(2*aT)+kb*cos(aT)
  if kformulaupdate > 0 then
    ; gui updates
    chnset Show, "id_a"
    chnset Show, "id_b"
    chnset Show, "id_m1"
    chnset Show, "id_m2"
    chnset Shide, "id_n1"
    chnset Shide, "id_n2"
    chnset Shide, "id_n3"
  endif

  ay1 = ka*cos(a1*$M_PI*2*km1*2)+kb*cos(a1*$M_PI*2*km2)
  ay2 = ka*cos(a2*$M_PI*2*km1*2)+kb*cos(a2*$M_PI*2*km2)
  ay_ref = ka*cos(aref*$M_PI*2*km1*2)+kb*cos(aref*$M_PI*2*km2)

endif

if kformula == 10 then
  ; from Christian on Csound list:
  ;aT  = ain*$M_PI*2
  ; hypocycloid
  ; ax =   krx*((1-a)*cos(ka*aT)+ka*kb*cos((1-a)*aT))
  ; krx = ka, ka=km1
  ; ay =   kry*((1-a)*sin(ka*aT)-ka*kb*sin((1-a)*aT))
  if kformulaupdate > 0 then
    ; gui updates
    chnset Show, "id_a"
    chnset Show, "id_b"
    chnset Show, "id_m1"
    chnset Show, "id_m2"
    chnset Shide, "id_n1"
    chnset Shide, "id_n2"
    chnset Shide, "id_n3"
  endif
  km1 = (km1-1)/20
  km2 = (km2-1)/20
  ay1 = ka*((1-km1)*cos(a1*$M_PI*2*km1)+ka*kb*cos((1-km1)*a1*$M_PI*2*km2))
  ay2 = ka*((1-km1)*cos(a2*$M_PI*2*km1)+ka*kb*cos((1-km1)*a2*$M_PI*2*km2))
  ay_ref = ka*((1-km1)*cos(aref*$M_PI*2*km1)+ka*kb*cos((1-km1)*aref*$M_PI*2*km2))
endif

koutlevel chnget "outlevel"
knorm_amp chnget "norm_amp"
;printk 1, knorm_amp
knorm chnget "norm"
knorm_amp = knorm > 0 ? knorm_amp : 1

aplotx = (ay_ref*cos(aref))*koutlevel*knorm_amp*0.3
aploty = ay_ref*sin(aref)*koutlevel*knorm_amp*0.3
display aplotx, 1/irefcps, 3
display aploty, 1/irefcps, 3

kpol chnget "polar"
if kpol > 0 then
  ay1 = ay1*sin(a1*$M_PI*2)
  ay2 = ay2*sin(a2*$M_PI*2)
  ay_ref = ay_ref*sin(aref*$M_PI*2)
else
  ay1 dcblock2 ay1
  ay2 dcblock2 ay2
  ay_ref dcblock2 ay_ref
endif



ay1 *= koutlevel * knorm_amp
ay2 *= koutlevel * knorm_amp
ay_ref *= koutlevel * knorm_amp

klim chnget "lim"
if klim > 0 then
  ay1 clip ay1, 0, 0.95
  ay2 clip ay2, 0, 0.95
  kref_lim chnget "ref_lim"
  if kref_lim > 0 then
    ay_ref clip ay_ref, 0, 0.95
  endif
endif

; oscilloscope and ref amp
aptr	phasor	irefcps
tablew	ay_ref,aptr,giview,1,0,0
knormpeak chnget "peak"
if knormpeak > 0 then
  knewpeak metro irefcps
  kamp_ref = knewpeak > 0 ? kamp_ref*0.9 : kamp_ref
  kamp_yref = knewpeak > 0 ? kamp_ref*0.9 : kamp_yref
  kamp_ref peak aref
  kamp_yref peak ay_ref
else
  kamp_ref rms aref
  kamp_yref rms ay_ref
endif
if metro(10)==1 then
  ;printk2 kamp_ref
  chnset	"tableNumbers(1)", "scopetable"	; update table display
endif
knorm2 chnget "norm2"
knorm_exp = knorm2 > 0 ? tonek((knorm*2)+1,1) : 1

chnset tonek(divz(kamp_ref, kamp_yref, 1)^knorm_exp, 1), "norm_amp"

adclck linseg 0, 2, 0, 1, 1, 1,  1
ay1 *= adclck
ay2 *= adclck
outs ay1, ay2
endin

</CsInstruments>
<CsScore>
i1 0 86400
</CsScore>
</CsoundSynthesizer>
