<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048    ; realtime audio out
-otanh_dist_mod.wav      ; output to audio file
</CsOptions>
<CsInstruments>

  sr = 48000
  ksmps = 100
  nchnls = 2
  0dbfs = 1

;***************************************************
;ftables
;***************************************************

 giSine ftgen 0, 0, 65536, 10, 1 ; sine
 ;giSample ftgen 0, 0, 0, 1, "StruglKor2mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "Askil2_4_mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "ce01_mono.wav", 0, 0, 0
 giSample1 ftgen 0, 0, 0, 1, "LAep3_mono.wav", 0, 0, 0
 giSample2 ftgen 0, 0, 0, 1, "MoodySlide2_110.wav", 0, 0, 0

;***************************************************
; modified tanh distortion
;***************************************************
instr 6

 iamp = ampdbfs(p4) ; Amp in -dB
 icps = p5 ; Frequency for the tone generator
 kDrive = p6

; amp envelope, so we can see some dynamic spectral changes related to the distortion effect
 iAttack = 0.01
 iDecay = 1
 iSustainLev = 0.5
 iRelease = 0.7
 aEnv adsr iAttack, iDecay, iSustainLev, iRelease

; audio generator
 a1 oscili aEnv, icps, giSine ; sine tone, with envelope
 a1 loscil 1, 1, giSample2, 1 ; test sample

; distortion
 kshape1 = p7 ; a
 kshape2 = p8 ; b
 kpreG = kDrive ; G
 kpostG = 1
 a2 = (exp(a1 * (kshape1 + kpreG)) - exp(a1 * (kshape2 - kpreG))) / (exp(a1 * kpreG) + exp(-a1 * kpreG))
 a2 = a2 * kpostG

; audio out
 outs a2*iamp, a2*iamp
  endin


</CsInstruments>
<CsScore>

; tanh dist
;           amp  cps  drive  A  B
i6  0    2  -5  440  1  0.5  0.0
i6  ^+3  .  .     .  2  .  .
i6  ^+3  .  .     .  4  .  .
i6  ^+3  .  .     .  7  .  .

i6  ^+4  2  -5  440  1  0.0  0.5
i6  ^+3  .  .     .  2  .  .
i6  ^+3  .  .     .  4  .  .
i6  ^+3  .  .     .  7  .  .

i6  ^+4  2  -7  440  1  0.7  0.3
i6  ^+3  .  .     .  2  .  .
i6  ^+3  .  .     .  4  .  .
i6  ^+3  .  .     .  7  .  .

</CsScore>
</CsoundSynthesizer>
