<CsoundSynthesizer>
<CsOptions>
;-odac0 -b1024 -B2048    ; realtime audio out
-owaveshaper.wav --displays  ; output to audio file
</CsOptions>
<CsInstruments>

  sr = 48000
  ksmps = 100
  nchnls = 2
  0dbfs = 1

;***************************************************
;ftables
;***************************************************

 giSine ftgen 0, 0, 65536, 10, 1 ; sine
 giSample1 ftgen 0, 0, 0, 1, "StruglKor2mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "Askil2_4_mono.wav", 0, 0, 0
 ;giSample ftgen 0, 0, 0, 1, "ce01_mono.wav", 0, 0, 0
 giSample2 ftgen 0, 0, 0, 1, "LAep3_mono.wav", 0, 0, 0
 giSample3 ftgen 0, 0, 0, 1, "MoodySlide2_110.wav", 0, 0, 0

 giLineRamp  ftgen  0, 0, 65537, 7, -1, 65536, 1      ; saw, line up
 giSigmoRise  ftgen  0, 0, 65537, 19, 0.5, 1, 270, 0      ; rising sigmoid (bipolar)

 ; waveshaping tables from Hans Mikelson instruments (�B increased table sizes for better resolution)
 giGentleDist ftgen 0, 0, 65537, 8, -1, 768, -0.99, 64000, 0.99, 768, 1 ; HM Gentle dist
 giValveDist ftgen 0, 0, 65537, 8, -1, 16384, -0.55, 16384, 0, 16384, 0.45, 16384, 1 ; HM Valve dist
 giNiceDist ftgen 0, 0, 65537, 13, 1, 1, 0, 2, 2, 1 ; HM Nice distortion
 giRoughCompress ftgen 0, 0, 65537, 8, -1, 16384, -0.8, 16384, 0, 16384, 0.8, 16384, 1 ; HM Rough compress
 gi2ndHarm ftgen 0, 0, 65537, 13, 1, 1, 0, 8, 1 ; HM 2nd harmonic
 gi2nd3rdHarm ftgen 0, 0, 65537, 13, 1, 1, 0, 8, 1, 1 ; HM 2nd & 3rd harmonics
 gi3rdHarm ftgen 0, 0, 65537, 13, 1, 1, 0, 0, 0, 1 ; HM 3rd harmonics (�B)
 giOddHarm ftgen 0, 0, 65537, 13, 1, 1, 0, 8, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1 ; HM even harmonics
 giEvenHarm ftgen 0, 0, 65537, 13, 1, 1, 0, 8, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1 ; HM odd harmonics

 giSquare ftgen 0, 0, 1025, 7, -1, 512, -1, 0, 1, 512, 1 ; square

 ; some rounded square shapes for different kinds of soft clipping
 giSoftSqare1 ftgen 0, 0, 65537, 8, -1, 8192, \
           -1, 49152, \
           1, 8192, 1  ; "soft" square
 giSoftSqare2 ftgen 0, 0, 65537, 8, -1, 16384, \
           -1, 32768, \
           1, 16384, 1  ; "soft" square
 giSoftSqare3 ftgen 0, 0, 65537, 8, -1, 16384, \
           -1, 8192,  \
           -1, 16386,  \
           1, 8192,   \
           1, 16384, 1  ; "soft" square
 giSoftSqare4 ftgen 0, 0, 65537, 8, -1, 24576, \
           -1, 4096,  \
           -1, 8192,  \
           1, 4096,   \
           1, 24576, 1  ; "soft" square

 ; Rectifier
 giRectifyLine ftgen 0, 0, 65537, 7, 1, 32768, 0, 32768, 1 ; Full wave rectify, equal to abs(x)
 giRectifyFFT ftgen 0, 0, 65537, 30, giRectifyLine, 1, 10 ; Filtered version of the above (will be bipolar)
 giRectifyFilt ftgen 0, 0, 65537, 24, giRectifyFFT, 0, 1 ; Rescale and offset the above so that it is normalized unipolar

 ; Crossover distortion (hard, line segments)
 giCrossDist ftgen 0, 0, 65537, 7, -1, 28672, -0.01, 8192, 0.01, 28672, 1
 giCrossDist2 ftgen 0, 0, 65537, 7, -1, 32700, -0.2, 136, 0.2, 32700, 1
 giCrossDist2h ftgen 0, 0, 65537, 7, -1, 32768, -0.2, 0, 0.2, 32768, 1
 giCrossDistFFT ftgen 0, 0, 65537, 30, giCrossDist, 1, 10 ; Filtered version of the above (will be bipolar)
 giCrossDist2FFT ftgen 0, 0, 65537, 30, giCrossDist2h, 1, 10 ; Filtered version of the above (will be bipolar)

 giWaveshapes ftgen 0, 0, 32, -2, giLineRamp, giSigmoRise,
     giGentleDist, giValveDist, giNiceDist, giRoughCompress,gi2ndHarm, gi2nd3rdHarm, gi3rdHarm, giOddHarm, giEvenHarm,
     giSquare, giSoftSqare1, giSoftSqare2,giSoftSqare3,giSoftSqare4,
     giRectifyLine, giRectifyFilt, giCrossDist, giCrossDist2, giCrossDistFFT, giCrossDist2FFT

;***************************************************
; Waveshaper
;***************************************************
 instr 5

 iamp = ampdbfs(p4) ; Amp in -dB
 iShapeNum = p5 ; waveshaper shape
 iShape table iShapeNum, giWaveshapes

; amp envelope, so we can see some dynamic spectral changes related to the distortion effect
 iAttack = 0.01
 iDecay = 1
 iSustainLev = 0.5
 iRelease = 0.7
 aEnv adsr iAttack, iDecay, iSustainLev, iRelease

; audio generator
 a1 oscili aEnv, 440, giSine ; sine tone, with envelope
 a1 loscil 1, 1, giSample2, 1 ; test sample, no envelope

; waveshaper
 a2 tablei a1*0.5, iShape, 1, 0.5, 0 ;
 a2 dcblock a2 ; prevent constant offset

; audio out
 outs a2*iamp, a2*iamp
endin

</CsInstruments>
<CsScore>
;   start  dur  amp  shape
i5  0  3  -5  0 ; line ramp 105
i5  ^+4  .  .  1; sigmo rise 106
i5  ^+4  .  .  3; valve dist 108
i5  ^+4  .  .  4; nice dist 109
i5  ^+4  .  .  8; 3rd Harm 113
i5  ^+4  .  .  9; odd harm 114
i5  ^+4  .  .  10; even harm 115
i5  ^+4  .  .  11; square 116
i5  ^+4  .  .  14; soft square 119
i5  ^+4  .  .  16; rectify line 121
i5  ^+4  .  .  17; rectify soft 123
i5  ^+4  .  .  18; crossover distortion 124
i5  ^+4  .  .  19; inverted crossover distortion 125
i5  ^+4  .  .  20; softened crossover distortion 127
i5  ^+4  .  .  21; softened inverted crossover distortion 128

</CsScore>
</CsoundSynthesizer>
